% -- corrmask.m
function mask = corrmask(ref,smp_freq,num_pulses,dPPM)
smp_time = 1 / smp_freq;

% Energy normalization
Epulse = (sum((ref.^2).*smp_time))/num_pulses;
ref = ref./sqrt(Epulse);

%ref = ref./sqrt( norm(ref)^2/(num_pulses*smp_freq) );

% Mask = (Reference signal) - (Shifted Reference Signal)
PPMsamples = floor (dPPM ./ smp_time);
idxToShift = PPMsamples;

% Make ref a column vector
if size(ref,1)==1
    ref = ref.';
end

mask = ref - circshift( ref, idxToShift );
%Y = circshift(A,K) circularly shifts the elements in array A by K positions
mask = mask.';

