% -- gaussian_wf.m
function p = gaussian_wf(fs, Tm, tau, N)
% INPUT: smp_freq, IR_duration, shape_factor, order
% OUTPUT: p

% -- START gaussian_wf.m
dt = 1/fs;
L = ceil(Tm/dt); % impulse response samples number
t = linspace(-Tm/2,Tm/2,L);

h = hermite_coeff(N);
sigma = sqrt( tau^2 / (4*pi) );
g = 1/(sqrt(2*pi) * sigma) * exp(-t.^2 / (2*sigma^2)); 
DNg = g .* (-1)^N ./ sigma^N .* polyval(h, t/sigma);%Y = polyval(P,X) returns the value of a polynomial P evaluated at X.

%norm(DNg)
p = DNg/(norm(DNg)*sqrt(dt));  % normalized pulse, energy = 1!
pulse_energy= sum(p.^2)*dt;
% -- END gaussian_wf.m
end

